# MatSeqSBAIJSetPreallocation

Creates a sparse symmetric matrix in block AIJ (block compressed row) format. For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased by more than a factor of 50.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode PETSCMAT_DLLEXPORT MatSeqSBAIJSetPreallocation(Mat B,PetscInt bs,PetscInt nz,const PetscInt nnz[])

Collective on Mat

### Input Parameters

| A | - the symmetric matrix
| bs | - size of block
| nz | - number of block nonzeros per block row (same for all rows)
| nnz | - array containing the number of block nonzeros in the upper triangular plus diagonal portion of each block (possibly different for each block row) or PETSC_NULL

### Options Database Keys

-mat_no_unroll -uses code that does not unroll the loops in the block calculations (much slower)
-mat_block_size -size of the blocks to use

### C++ variants

| MatSeqSBAIJSetPreallocation(Mat A,PetscInt bs,const PetscInt nnz[]) |  | -> |  | MatSeqSBAIJSetPreallocation(A,bs,0,nnz)

### Notes

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=PETSC_NULL for PETSc to control dynamic memory allocation. For additional details, see the users manual chapter on matrices.

If the nnz parameter is given then the nz parameter is ignored

### See Also

MatCreate(), MatCreateSeqAIJ(), MatSetValues(), MatCreateMPISBAIJ()

Level:intermediate
Location:src/mat/impls/sbaij/seq/sbaij.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages